# coding: utf-8

"""
    Spryngtime Usage Analytics & Billing API

    Spryngtime Usage Analytics & Billing API

    The version of the OpenAPI document: 1.0.0
    Generated by: https://konfigthis.com
"""

from dataclasses import dataclass
import typing_extensions
import urllib3
from pydantic import RootModel
from spryngtime_analytics_sdk.request_before_hook import request_before_hook
import json
from urllib3._collections import HTTPHeaderDict

from spryngtime_analytics_sdk.api_response import AsyncGeneratorResponse
from spryngtime_analytics_sdk import api_client, exceptions
from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from spryngtime_analytics_sdk import schemas  # noqa: F401

from spryngtime_analytics_sdk.model.track_usage_request import TrackUsageRequest as TrackUsageRequestSchema
from spryngtime_analytics_sdk.model.open_ai_response import OpenAiResponse as OpenAiResponseSchema
from spryngtime_analytics_sdk.model.usage_detail import UsageDetail as UsageDetailSchema

from spryngtime_analytics_sdk.type.track_usage_request import TrackUsageRequest
from spryngtime_analytics_sdk.type.usage_detail import UsageDetail
from spryngtime_analytics_sdk.type.open_ai_response import OpenAiResponse

from ...api_client import Dictionary
from spryngtime_analytics_sdk.pydantic.track_usage_request import TrackUsageRequest as TrackUsageRequestPydantic
from spryngtime_analytics_sdk.pydantic.open_ai_response import OpenAiResponse as OpenAiResponsePydantic
from spryngtime_analytics_sdk.pydantic.usage_detail import UsageDetail as UsageDetailPydantic

from . import path

# body param
SchemaForRequestBodyApplicationJson = TrackUsageRequestSchema


request_body_track_usage_request = api_client.RequestBody(
    content={
        'application/json': api_client.MediaType(
            schema=SchemaForRequestBodyApplicationJson),
    },
    required=True,
)
_auth = [
    'ApiKeyAuth',
]


@dataclass
class ApiResponseFor200(api_client.ApiResponse):
    body: schemas.Unset = schemas.unset


@dataclass
class ApiResponseFor200Async(api_client.AsyncApiResponse):
    body: schemas.Unset = schemas.unset


_response_for_200 = api_client.OpenApiResponse(
    response_cls=ApiResponseFor200,
    response_cls_async=ApiResponseFor200Async,
)


@dataclass
class ApiResponseFor401(api_client.ApiResponse):
    body: schemas.Unset = schemas.unset


@dataclass
class ApiResponseFor401Async(api_client.AsyncApiResponse):
    body: schemas.Unset = schemas.unset


_response_for_401 = api_client.OpenApiResponse(
    response_cls=ApiResponseFor401,
    response_cls_async=ApiResponseFor401Async,
)


@dataclass
class ApiResponseFor500(api_client.ApiResponse):
    body: schemas.Unset = schemas.unset


@dataclass
class ApiResponseFor500Async(api_client.AsyncApiResponse):
    body: schemas.Unset = schemas.unset


_response_for_500 = api_client.OpenApiResponse(
    response_cls=ApiResponseFor500,
    response_cls_async=ApiResponseFor500Async,
)
_status_code_to_response = {
    '200': _response_for_200,
    '401': _response_for_401,
    '500': _response_for_500,
}


class BaseApi(api_client.Api):

    def _track_usage_mapped_args(
        self,
        key: str,
        conversation_id: typing.Optional[str] = None,
        open_ai_response: typing.Optional[OpenAiResponse] = None,
        usage: typing.Optional[UsageDetail] = None,
    ) -> api_client.MappedArgs:
        args: api_client.MappedArgs = api_client.MappedArgs()
        _body = {}
        if key is not None:
            _body["key"] = key
        if conversation_id is not None:
            _body["conversationId"] = conversation_id
        if open_ai_response is not None:
            _body["openAiResponse"] = open_ai_response
        if usage is not None:
            _body["usage"] = usage
        args.body = _body
        return args

    async def _atrack_usage_oapg(
        self,
        body: typing.Any = None,
        skip_deserialization: bool = True,
        timeout: typing.Optional[typing.Union[float, typing.Tuple]] = None,
        content_type: str = 'application/json',
        stream: bool = False,
        **kwargs,
    ) -> typing.Union[
        ApiResponseFor200Async,
        api_client.ApiResponseWithoutDeserializationAsync,
        AsyncGeneratorResponse,
    ]:
        """
        Track usage data
        :param skip_deserialization: If true then api_response.response will be set but
            api_response.body and api_response.headers will not be deserialized into schema
            class instances
        """
        used_path = path.value
    
        _headers = HTTPHeaderDict()
        # TODO add cookie handling
        method = 'post'.upper()
        _headers.add('Content-Type', content_type)
    
        if body is schemas.unset:
            raise exceptions.ApiValueError(
                'The required body parameter has an invalid value of: unset. Set a valid value instead')
        _fields = None
        _body = None
        request_before_hook(
            resource_path=used_path,
            method=method,
            configuration=self.api_client.configuration,
            body=body,
            auth_settings=_auth,
            headers=_headers,
        )
        serialized_data = request_body_track_usage_request.serialize(body, content_type)
        if 'fields' in serialized_data:
            _fields = serialized_data['fields']
        elif 'body' in serialized_data:
            _body = serialized_data['body']
    
        response = await self.api_client.async_call_api(
            resource_path=used_path,
            method=method,
            headers=_headers,
            fields=_fields,
            serialized_body=_body,
            body=body,
            auth_settings=_auth,
            timeout=timeout,
            **kwargs
        )
    
        if stream:
            if not 200 <= response.http_response.status <= 299:
                body = (await response.http_response.content.read()).decode("utf-8")
                raise exceptions.ApiStreamingException(
                    status=response.http_response.status,
                    reason=response.http_response.reason,
                    body=body,
                )
    
            async def stream_iterator():
                """
                iterates over response.http_response.content and closes connection once iteration has finished
                """
                async for line in response.http_response.content:
                    if line == b'\r\n':
                        continue
                    yield line
                response.http_response.close()
                await response.session.close()
            return AsyncGeneratorResponse(
                content=stream_iterator(),
                headers=response.http_response.headers,
                status=response.http_response.status,
                response=response.http_response
            )
    
        response_for_status = _status_code_to_response.get(str(response.http_response.status))
        if response_for_status:
            api_response = await response_for_status.deserialize_async(
                                                    response,
                                                    self.api_client.configuration,
                                                    skip_deserialization=skip_deserialization
                                                )
        else:
            # If response data is JSON then deserialize for SDK consumer convenience
            is_json = api_client.JSONDetector._content_type_is_json(response.http_response.headers.get('Content-Type', ''))
            api_response = api_client.ApiResponseWithoutDeserializationAsync(
                body=await response.http_response.json() if is_json else await response.http_response.text(),
                response=response.http_response,
                round_trip_time=response.round_trip_time,
                status=response.http_response.status,
                headers=response.http_response.headers,
            )
    
        if not 200 <= api_response.status <= 299:
            raise exceptions.ApiException(api_response=api_response)
    
        # cleanup session / response
        response.http_response.close()
        await response.session.close()
    
        return api_response


    def _track_usage_oapg(
        self,
        body: typing.Any = None,
        skip_deserialization: bool = True,
        timeout: typing.Optional[typing.Union[float, typing.Tuple]] = None,
        content_type: str = 'application/json',
        stream: bool = False,
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization,
    ]:
        """
        Track usage data
        :param skip_deserialization: If true then api_response.response will be set but
            api_response.body and api_response.headers will not be deserialized into schema
            class instances
        """
        used_path = path.value
    
        _headers = HTTPHeaderDict()
        # TODO add cookie handling
        method = 'post'.upper()
        _headers.add('Content-Type', content_type)
    
        if body is schemas.unset:
            raise exceptions.ApiValueError(
                'The required body parameter has an invalid value of: unset. Set a valid value instead')
        _fields = None
        _body = None
        request_before_hook(
            resource_path=used_path,
            method=method,
            configuration=self.api_client.configuration,
            body=body,
            auth_settings=_auth,
            headers=_headers,
        )
        serialized_data = request_body_track_usage_request.serialize(body, content_type)
        if 'fields' in serialized_data:
            _fields = serialized_data['fields']
        elif 'body' in serialized_data:
            _body = serialized_data['body']
    
        response = self.api_client.call_api(
            resource_path=used_path,
            method=method,
            headers=_headers,
            fields=_fields,
            serialized_body=_body,
            body=body,
            auth_settings=_auth,
            timeout=timeout,
        )
    
        response_for_status = _status_code_to_response.get(str(response.http_response.status))
        if response_for_status:
            api_response = response_for_status.deserialize(
                                                    response,
                                                    self.api_client.configuration,
                                                    skip_deserialization=skip_deserialization
                                                )
        else:
            # If response data is JSON then deserialize for SDK consumer convenience
            is_json = api_client.JSONDetector._content_type_is_json(response.http_response.headers.get('Content-Type', ''))
            api_response = api_client.ApiResponseWithoutDeserialization(
                body=json.loads(response.http_response.data) if is_json else response.http_response.data,
                response=response.http_response,
                round_trip_time=response.round_trip_time,
                status=response.http_response.status,
                headers=response.http_response.headers,
            )
    
        if not 200 <= api_response.status <= 299:
            raise exceptions.ApiException(api_response=api_response)
    
        return api_response


class TrackUsageRaw(BaseApi):
    # this class is used by api classes that refer to endpoints with operationId fn names

    async def atrack_usage(
        self,
        key: str,
        conversation_id: typing.Optional[str] = None,
        open_ai_response: typing.Optional[OpenAiResponse] = None,
        usage: typing.Optional[UsageDetail] = None,
        **kwargs,
    ) -> typing.Union[
        ApiResponseFor200Async,
        api_client.ApiResponseWithoutDeserializationAsync,
        AsyncGeneratorResponse,
    ]:
        args = self._track_usage_mapped_args(
            key=key,
            conversation_id=conversation_id,
            open_ai_response=open_ai_response,
            usage=usage,
        )
        return await self._atrack_usage_oapg(
            body=args.body,
            **kwargs,
        )
    
    def track_usage(
        self,
        key: str,
        conversation_id: typing.Optional[str] = None,
        open_ai_response: typing.Optional[OpenAiResponse] = None,
        usage: typing.Optional[UsageDetail] = None,
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization,
    ]:
        args = self._track_usage_mapped_args(
            key=key,
            conversation_id=conversation_id,
            open_ai_response=open_ai_response,
            usage=usage,
        )
        return self._track_usage_oapg(
            body=args.body,
        )

class TrackUsage(BaseApi):

    async def atrack_usage(
        self,
        key: str,
        conversation_id: typing.Optional[str] = None,
        open_ai_response: typing.Optional[OpenAiResponse] = None,
        usage: typing.Optional[UsageDetail] = None,
        validate: bool = False,
        **kwargs,
    ) -> None:
        raw_response = await self.raw.atrack_usage(
            key=key,
            conversation_id=conversation_id,
            open_ai_response=open_ai_response,
            usage=usage,
            **kwargs,
        )
    
    
    def track_usage(
        self,
        key: str,
        conversation_id: typing.Optional[str] = None,
        open_ai_response: typing.Optional[OpenAiResponse] = None,
        usage: typing.Optional[UsageDetail] = None,
        validate: bool = False,
    ) -> None:
        raw_response = self.raw.track_usage(
            key=key,
            conversation_id=conversation_id,
            open_ai_response=open_ai_response,
            usage=usage,
        )


class ApiForpost(BaseApi):
    # this class is used by api classes that refer to endpoints by path and http method names

    async def apost(
        self,
        key: str,
        conversation_id: typing.Optional[str] = None,
        open_ai_response: typing.Optional[OpenAiResponse] = None,
        usage: typing.Optional[UsageDetail] = None,
        **kwargs,
    ) -> typing.Union[
        ApiResponseFor200Async,
        api_client.ApiResponseWithoutDeserializationAsync,
        AsyncGeneratorResponse,
    ]:
        args = self._track_usage_mapped_args(
            key=key,
            conversation_id=conversation_id,
            open_ai_response=open_ai_response,
            usage=usage,
        )
        return await self._atrack_usage_oapg(
            body=args.body,
            **kwargs,
        )
    
    def post(
        self,
        key: str,
        conversation_id: typing.Optional[str] = None,
        open_ai_response: typing.Optional[OpenAiResponse] = None,
        usage: typing.Optional[UsageDetail] = None,
    ) -> typing.Union[
        ApiResponseFor200,
        api_client.ApiResponseWithoutDeserialization,
    ]:
        args = self._track_usage_mapped_args(
            key=key,
            conversation_id=conversation_id,
            open_ai_response=open_ai_response,
            usage=usage,
        )
        return self._track_usage_oapg(
            body=args.body,
        )

